Index: trunk/src/VBox/Additions/WINNT/Graphics/Display/Makefile.kmk
===================================================================
--- trunk/src/VBox/Additions/WINNT/Graphics/Display/Makefile.kmk	(revision 8515)
+++ trunk/src/VBox/Additions/WINNT/Graphics/Display/Makefile.kmk	(revision 8760)
@@ -22,5 +22,5 @@
 DEPTH ?= ../../../../../..
 SUB_DEPTH = ../../..
-include	$(PATH_KBUILD)/subheader.kmk
+include	$(KBUILD_PATH)/subheader.kmk
 
 SYSMODS += VBoxDisp
@@ -63,4 +63,4 @@
 
 
-include	$(PATH_KBUILD)/subfooter.kmk
+include	$(KBUILD_PATH)/subfooter.kmk
 
Index: trunk/src/VBox/Additions/WINNT/Graphics/Display/Mirror/Makefile.kmk
===================================================================
--- trunk/src/VBox/Additions/WINNT/Graphics/Display/Mirror/Makefile.kmk	(revision 8515)
+++ trunk/src/VBox/Additions/WINNT/Graphics/Display/Mirror/Makefile.kmk	(revision 8760)
@@ -22,5 +22,5 @@
 DEPTH ?= ../../../../../../..
 SUB_DEPTH = ../../../..
-include	$(PATH_KBUILD)/subheader.kmk
+include	$(KBUILD_PATH)/subheader.kmk
 
 SYSMODS += vrdpdd
@@ -43,4 +43,4 @@
 
 
-include	$(PATH_KBUILD)/subfooter.kmk
+include	$(KBUILD_PATH)/subfooter.kmk
 
Index: trunk/src/VBox/Additions/WINNT/Graphics/Makefile.kmk
===================================================================
--- trunk/src/VBox/Additions/WINNT/Graphics/Makefile.kmk	(revision 8515)
+++ trunk/src/VBox/Additions/WINNT/Graphics/Makefile.kmk	(revision 8760)
@@ -22,5 +22,5 @@
 DEPTH ?= ../../../../..
 SUB_DEPTH = ../..
-include	$(PATH_KBUILD)/subheader.kmk
+include	$(KBUILD_PATH)/subheader.kmk
 
 # Include sub-makefiles.
@@ -45,5 +45,5 @@
 	$(PATH_TARGET)/VBoxVideoCat.dir/VBoxDisp.dll \
 	$(PATH_TARGET)/VBoxVideoCat.dir/VBoxVideo.cat
-VBoxVideo-inf_CLEAN = $(VBoxVideo-inf_SOURCES) 
+VBoxVideo-inf_CLEAN = $(VBoxVideo-inf_SOURCES)
 VBoxVideo-inf_BLDDIRS = $(PATH_TARGET)/VBoxVideoCat.dir
 
@@ -67,4 +67,4 @@
 endif # signing
 
-include	$(PATH_KBUILD)/subfooter.kmk
+include	$(KBUILD_PATH)/subfooter.kmk
 
Index: trunk/src/VBox/Additions/WINNT/Graphics/Miniport/Makefile.kmk
===================================================================
--- trunk/src/VBox/Additions/WINNT/Graphics/Miniport/Makefile.kmk	(revision 8515)
+++ trunk/src/VBox/Additions/WINNT/Graphics/Miniport/Makefile.kmk	(revision 8760)
@@ -22,5 +22,5 @@
 DEPTH ?= ../../../../../..
 SUB_DEPTH = ../../..
-include	$(PATH_KBUILD)/subheader.kmk
+include	$(KBUILD_PATH)/subheader.kmk
 
 
@@ -50,4 +50,4 @@
 	$(PATH_LIB)/additions/RuntimeW32NT4GuestR0$(VBOXW32GUEST_SUFF_LIB)
 
-include	$(PATH_KBUILD)/subfooter.kmk
+include	$(KBUILD_PATH)/subfooter.kmk
 
Index: trunk/src/VBox/Additions/WINNT/Graphics/Miniport/Mirror/Makefile.kmk
===================================================================
--- trunk/src/VBox/Additions/WINNT/Graphics/Miniport/Mirror/Makefile.kmk	(revision 8515)
+++ trunk/src/VBox/Additions/WINNT/Graphics/Miniport/Mirror/Makefile.kmk	(revision 8760)
@@ -22,5 +22,5 @@
 DEPTH ?= ../../../../../../..
 SUB_DEPTH = ../../../../
-include	$(PATH_KBUILD)/subheader.kmk
+include	$(KBUILD_PATH)/subheader.kmk
 
 SYSMODS += vrdpvd
@@ -41,4 +41,4 @@
 	$(PATH_LIB)/additions/RuntimeW32GuestR0$(VBOXW32GUEST_SUFF_LIB)
 
-include	$(PATH_KBUILD)/subfooter.kmk
+include	$(KBUILD_PATH)/subfooter.kmk
 
Index: trunk/src/VBox/Additions/WINNT/Graphics/OpenGL/Makefile.kmk
===================================================================
--- trunk/src/VBox/Additions/WINNT/Graphics/OpenGL/Makefile.kmk	(revision 8515)
+++ trunk/src/VBox/Additions/WINNT/Graphics/OpenGL/Makefile.kmk	(revision 8760)
@@ -22,5 +22,5 @@
 DEPTH ?= ../../../../../..
 SUB_DEPTH = ../../..
-include	$(PATH_KBUILD)/subheader.kmk
+include	$(KBUILD_PATH)/subheader.kmk
 
 # Include sub-makefile(s).
@@ -48,4 +48,4 @@
 	$(PATH_LIB)/additions/RuntimeW32GuestR3.lib
 
-include	$(PATH_KBUILD)/subfooter.kmk
+include	$(KBUILD_PATH)/subfooter.kmk
 
Index: trunk/src/VBox/Additions/WINNT/Graphics/OpenGL/test/Makefile.kmk
===================================================================
--- trunk/src/VBox/Additions/WINNT/Graphics/OpenGL/test/Makefile.kmk	(revision 8515)
+++ trunk/src/VBox/Additions/WINNT/Graphics/OpenGL/test/Makefile.kmk	(revision 8760)
@@ -22,5 +22,5 @@
 DEPTH ?= ../../../../../../..
 SUB_DEPTH = ../../../..
-include $(PATH_KBUILD)/subheader.kmk
+include $(KBUILD_PATH)/subheader.kmk
 
 ifdef VBOX_WITH_TESTCASES
@@ -37,10 +37,10 @@
 
 tstOGLSample_TEMPLATE = VBOXW32GUESTR3
-tstOGLSample_DEFS     = 
+tstOGLSample_DEFS     =
 tstOGLSample_SOURCES  = tstOGLSample.cpp
 tstOGLSample_LIBS     = $(PATH_SDK_W2K3DDKX86_LIB)/opengl32.lib
 
 tstOGLSphere_TEMPLATE = VBOXW32GUESTR3
-tstOGLSphere_DEFS     = 
+tstOGLSphere_DEFS     =
 tstOGLSphere_SOURCES  = tstOGLSphere.c
 tstOGLSphere_LIBS     = $(PATH_SDK_W2K3DDKX86_LIB)/opengl32.lib
@@ -48,4 +48,4 @@
 endif # VBOX_WITH_TESTCASES
 
-include $(PATH_KBUILD)/subfooter.kmk
+include $(KBUILD_PATH)/subfooter.kmk
 