Index: trunk/include/VBox/ostypes.h
===================================================================
--- trunk/include/VBox/ostypes.h	(revision 8802)
+++ trunk/include/VBox/ostypes.h	(revision 8803)
@@ -45,42 +45,43 @@
 typedef enum VBOXOSTYPE
 {
-    VBOXOSTYPE_Unknown   = 0,
-    VBOXOSTYPE_DOS       = 0x10000,
-    VBOXOSTYPE_Win31     = 0x15000,
-    VBOXOSTYPE_Win9x     = 0x20000,
-    VBOXOSTYPE_Win95     = 0x21000,
-    VBOXOSTYPE_Win98     = 0x22000,
-    VBOXOSTYPE_WinMe     = 0x23000,
-    VBOXOSTYPE_WinNT     = 0x30000,
-    VBOXOSTYPE_WinNT4    = 0x31000,
-    VBOXOSTYPE_Win2k     = 0x32000,
-    VBOXOSTYPE_WinXP     = 0x33000,
-    VBOXOSTYPE_Win2k3    = 0x34000,
-    VBOXOSTYPE_WinVista  = 0x35000,
-    VBOXOSTYPE_Win2k8    = 0x36000,
-    VBOXOSTYPE_OS2       = 0x40000,
-    VBOXOSTYPE_OS2Warp3  = 0x41000,
-    VBOXOSTYPE_OS2Warp4  = 0x42000,
-    VBOXOSTYPE_OS2Warp45 = 0x43000,
-    VBOXOSTYPE_ECS       = 0x44000,
-    VBOXOSTYPE_Linux     = 0x50000,
-    VBOXOSTYPE_Linux22   = 0x51000,
-    VBOXOSTYPE_Linux24   = 0x52000,
-    VBOXOSTYPE_Linux26   = 0x53000,
-    VBOXOSTYPE_ArchLinux = 0x54000,
-    VBOXOSTYPE_Debian    = 0x55000,
-    VBOXOSTYPE_OpenSUSE  = 0x56000,
-    VBOXOSTYPE_FedoraCore= 0x57000,
-    VBOXOSTYPE_Gentoo    = 0x58000,
-    VBOXOSTYPE_Mandriva  = 0x59000,
-    VBOXOSTYPE_RedHat    = 0x5A000,
-    VBOXOSTYPE_Ubuntu    = 0x5B000,
-    VBOXOSTYPE_Xandros   = 0x5C000,
-    VBOXOSTYPE_FreeBSD   = 0x60000,
-    VBOXOSTYPE_OpenBSD   = 0x61000,
-    VBOXOSTYPE_NetBSD    = 0x62000,
-    VBOXOSTYPE_Netware   = 0x70000,
-    VBOXOSTYPE_Solaris   = 0x80000,
-    VBOXOSTYPE_L4        = 0x90000,
+    VBOXOSTYPE_Unknown     = 0,
+    VBOXOSTYPE_DOS         = 0x10000,
+    VBOXOSTYPE_Win31       = 0x15000,
+    VBOXOSTYPE_Win9x       = 0x20000,
+    VBOXOSTYPE_Win95       = 0x21000,
+    VBOXOSTYPE_Win98       = 0x22000,
+    VBOXOSTYPE_WinMe       = 0x23000,
+    VBOXOSTYPE_WinNT       = 0x30000,
+    VBOXOSTYPE_WinNT4      = 0x31000,
+    VBOXOSTYPE_Win2k       = 0x32000,
+    VBOXOSTYPE_WinXP       = 0x33000,
+    VBOXOSTYPE_Win2k3      = 0x34000,
+    VBOXOSTYPE_WinVista    = 0x35000,
+    VBOXOSTYPE_Win2k8      = 0x36000,
+    VBOXOSTYPE_OS2         = 0x40000,
+    VBOXOSTYPE_OS2Warp3    = 0x41000,
+    VBOXOSTYPE_OS2Warp4    = 0x42000,
+    VBOXOSTYPE_OS2Warp45   = 0x43000,
+    VBOXOSTYPE_ECS         = 0x44000,
+    VBOXOSTYPE_Linux       = 0x50000,
+    VBOXOSTYPE_Linux22     = 0x51000,
+    VBOXOSTYPE_Linux24     = 0x52000,
+    VBOXOSTYPE_Linux26     = 0x53000,
+    VBOXOSTYPE_ArchLinux   = 0x54000,
+    VBOXOSTYPE_Debian      = 0x55000,
+    VBOXOSTYPE_OpenSUSE    = 0x56000,
+    VBOXOSTYPE_FedoraCore  = 0x57000,
+    VBOXOSTYPE_Gentoo      = 0x58000,
+    VBOXOSTYPE_Mandriva    = 0x59000,
+    VBOXOSTYPE_RedHat      = 0x5A000,
+    VBOXOSTYPE_Ubuntu      = 0x5B000,
+    VBOXOSTYPE_Xandros     = 0x5C000,
+    VBOXOSTYPE_FreeBSD     = 0x60000,
+    VBOXOSTYPE_OpenBSD     = 0x61000,
+    VBOXOSTYPE_NetBSD      = 0x62000,
+    VBOXOSTYPE_Netware     = 0x70000,
+    VBOXOSTYPE_Solaris     = 0x80000,
+	VBOXOSTYPE_OpenSolaris = 0x81000,
+    VBOXOSTYPE_L4          = 0x90000,
     /** The usual 32-bit hack. */
     VBOXOSTYPE_32BIT_HACK = 0x7fffffff
@@ -90,3 +91,2 @@
 
 #endif
-
Index: trunk/src/VBox/Main/VirtualBoxImpl.cpp
===================================================================
--- trunk/src/VBox/Main/VirtualBoxImpl.cpp	(revision 8802)
+++ trunk/src/VBox/Main/VirtualBoxImpl.cpp	(revision 8803)
@@ -4490,38 +4490,39 @@
          * NOTE2: please use powers of 2 when specifying the size of harddisks since
          *        '2GB' looks better than '1.95GB' (= 2000MB) */
-        { SchemaDefs_OSTypeId_unknown,   tr ("Other/Unknown"),  VBOXOSTYPE_Unknown,    64,   4,  2 * _1K },
-        { SchemaDefs_OSTypeId_dos,       "DOS",                 VBOXOSTYPE_DOS,        32,   4,      512 },
-        { SchemaDefs_OSTypeId_win31,     "Windows 3.1",         VBOXOSTYPE_Win31,      32,   4,  1 * _1K },
-        { SchemaDefs_OSTypeId_win95,     "Windows 95",          VBOXOSTYPE_Win95,      64,   4,  2 * _1K },
-        { SchemaDefs_OSTypeId_win98,     "Windows 98",          VBOXOSTYPE_Win98,      64,   4,  2 * _1K },
-        { SchemaDefs_OSTypeId_winme,     "Windows Me",          VBOXOSTYPE_WinMe,      64,   4,  4 * _1K },
-        { SchemaDefs_OSTypeId_winnt4,    "Windows NT 4",        VBOXOSTYPE_WinNT4,    128,   4,  2 * _1K },
-        { SchemaDefs_OSTypeId_win2k,     "Windows 2000",        VBOXOSTYPE_Win2k,     168,  12,  4 * _1K },
-        { SchemaDefs_OSTypeId_winxp,     "Windows XP",          VBOXOSTYPE_WinXP,     192,  12, 10 * _1K },
-        { SchemaDefs_OSTypeId_win2k3,    "Windows Server 2003", VBOXOSTYPE_Win2k3,    256,  12, 20 * _1K },
-        { SchemaDefs_OSTypeId_winvista,  "Windows Vista",       VBOXOSTYPE_WinVista,  512,  12, 20 * _1K },
-        { SchemaDefs_OSTypeId_win2k8,    "Windows Server 2008", VBOXOSTYPE_Win2k8,    256,  12, 20 * _1K },
-        { SchemaDefs_OSTypeId_os2warp3,  "OS/2 Warp 3",         VBOXOSTYPE_OS2Warp3,   48,   4,  1 * _1K },
-        { SchemaDefs_OSTypeId_os2warp4,  "OS/2 Warp 4",         VBOXOSTYPE_OS2Warp4,   64,   4,  2 * _1K },
-        { SchemaDefs_OSTypeId_os2warp45, "OS/2 Warp 4.5",       VBOXOSTYPE_OS2Warp45,  96,   4,  2 * _1K },
-        { SchemaDefs_OSTypeId_ecs,       "eComStation",         VBOXOSTYPE_ECS,        96,   4,  2 * _1K },
-        { SchemaDefs_OSTypeId_linux22,   "Linux 2.2",           VBOXOSTYPE_Linux22,    64,   4,  2 * _1K },
-        { SchemaDefs_OSTypeId_linux24,   "Linux 2.4",           VBOXOSTYPE_Linux24,   128,   4,  4 * _1K },
-        { SchemaDefs_OSTypeId_linux26,   "Linux 2.6",           VBOXOSTYPE_Linux26,   256,   4,  8 * _1K },
-        { SchemaDefs_OSTypeId_archlinux, "Arch Linux",          VBOXOSTYPE_ArchLinux, 256,  12,  8 * _1K },
-        { SchemaDefs_OSTypeId_debian,    "Debian",              VBOXOSTYPE_Debian,    256,  12,  8 * _1K },
-        { SchemaDefs_OSTypeId_opensuse,  "openSUSE",            VBOXOSTYPE_OpenSUSE,  256,  12,  8 * _1K },
-        { SchemaDefs_OSTypeId_fedoracore,"Fedora",              VBOXOSTYPE_FedoraCore,256,  12,  8 * _1K },
-        { SchemaDefs_OSTypeId_gentoo,    "Gentoo Linux",        VBOXOSTYPE_Gentoo,    256,  12,  8 * _1K },
-        { SchemaDefs_OSTypeId_mandriva,  "Mandriva",            VBOXOSTYPE_Mandriva,  256,  12,  8 * _1K },
-        { SchemaDefs_OSTypeId_redhat,    "Red Hat",             VBOXOSTYPE_RedHat,    256,  12,  8 * _1K },
-        { SchemaDefs_OSTypeId_ubuntu,    "Ubuntu",              VBOXOSTYPE_Ubuntu,    256,  12,  8 * _1K },
-        { SchemaDefs_OSTypeId_xandros,   "Xandros",             VBOXOSTYPE_Xandros,   256,  12,  8 * _1K },
-        { SchemaDefs_OSTypeId_freebsd,   "FreeBSD",             VBOXOSTYPE_FreeBSD,    64,   4,  2 * _1K },
-        { SchemaDefs_OSTypeId_openbsd,   "OpenBSD",             VBOXOSTYPE_OpenBSD,    64,   4,  2 * _1K },
-        { SchemaDefs_OSTypeId_netbsd,    "NetBSD",              VBOXOSTYPE_NetBSD,     64,   4,  2 * _1K },
-        { SchemaDefs_OSTypeId_netware,   "Netware",             VBOXOSTYPE_Netware,   128,   4,  4 * _1K },
-        { SchemaDefs_OSTypeId_solaris,   "Solaris",             VBOXOSTYPE_Solaris,   512,  12, 16 * _1K },
-        { SchemaDefs_OSTypeId_l4,        "L4",                  VBOXOSTYPE_L4,         64,   4,  2 * _1K }
+        { SchemaDefs_OSTypeId_unknown,     tr ("Other/Unknown"),  VBOXOSTYPE_Unknown,      64,   4,  2 * _1K },
+        { SchemaDefs_OSTypeId_dos,         "DOS",                 VBOXOSTYPE_DOS,          32,   4,      512 },
+        { SchemaDefs_OSTypeId_win31,       "Windows 3.1",         VBOXOSTYPE_Win31,        32,   4,  1 * _1K },
+        { SchemaDefs_OSTypeId_win95,       "Windows 95",          VBOXOSTYPE_Win95,        64,   4,  2 * _1K },
+        { SchemaDefs_OSTypeId_win98,       "Windows 98",          VBOXOSTYPE_Win98,        64,   4,  2 * _1K },
+        { SchemaDefs_OSTypeId_winme,       "Windows Me",          VBOXOSTYPE_WinMe,        64,   4,  4 * _1K },
+        { SchemaDefs_OSTypeId_winnt4,      "Windows NT 4",        VBOXOSTYPE_WinNT4,      128,   4,  2 * _1K },
+        { SchemaDefs_OSTypeId_win2k,       "Windows 2000",        VBOXOSTYPE_Win2k,       168,  12,  4 * _1K },
+        { SchemaDefs_OSTypeId_winxp,       "Windows XP",          VBOXOSTYPE_WinXP,       192,  12, 10 * _1K },
+        { SchemaDefs_OSTypeId_win2k3,      "Windows Server 2003", VBOXOSTYPE_Win2k3,      256,  12, 20 * _1K },
+        { SchemaDefs_OSTypeId_winvista,    "Windows Vista",       VBOXOSTYPE_WinVista,    512,  12, 20 * _1K },
+        { SchemaDefs_OSTypeId_win2k8,      "Windows Server 2008", VBOXOSTYPE_Win2k8,      256,  12, 20 * _1K },
+        { SchemaDefs_OSTypeId_os2warp3,    "OS/2 Warp 3",         VBOXOSTYPE_OS2Warp3,     48,   4,  1 * _1K },
+        { SchemaDefs_OSTypeId_os2warp4,    "OS/2 Warp 4",         VBOXOSTYPE_OS2Warp4,     64,   4,  2 * _1K },
+        { SchemaDefs_OSTypeId_os2warp45,   "OS/2 Warp 4.5",       VBOXOSTYPE_OS2Warp45,    96,   4,  2 * _1K },
+        { SchemaDefs_OSTypeId_ecs,         "eComStation",         VBOXOSTYPE_ECS,          96,   4,  2 * _1K },
+        { SchemaDefs_OSTypeId_linux22,     "Linux 2.2",           VBOXOSTYPE_Linux22,      64,   4,  2 * _1K },
+        { SchemaDefs_OSTypeId_linux24,     "Linux 2.4",           VBOXOSTYPE_Linux24,     128,   4,  4 * _1K },
+        { SchemaDefs_OSTypeId_linux26,     "Linux 2.6",           VBOXOSTYPE_Linux26,     256,   4,  8 * _1K },
+        { SchemaDefs_OSTypeId_archlinux,   "Arch Linux",          VBOXOSTYPE_ArchLinux,   256,  12,  8 * _1K },
+        { SchemaDefs_OSTypeId_debian,      "Debian",              VBOXOSTYPE_Debian,      256,  12,  8 * _1K },
+        { SchemaDefs_OSTypeId_opensuse,    "openSUSE",            VBOXOSTYPE_OpenSUSE,    256,  12,  8 * _1K },
+        { SchemaDefs_OSTypeId_fedoracore,  "Fedora",              VBOXOSTYPE_FedoraCore,  256,  12,  8 * _1K },
+        { SchemaDefs_OSTypeId_gentoo,      "Gentoo Linux",        VBOXOSTYPE_Gentoo,      256,  12,  8 * _1K },
+        { SchemaDefs_OSTypeId_mandriva,    "Mandriva",            VBOXOSTYPE_Mandriva,    256,  12,  8 * _1K },
+        { SchemaDefs_OSTypeId_redhat,      "Red Hat",             VBOXOSTYPE_RedHat,      256,  12,  8 * _1K },
+        { SchemaDefs_OSTypeId_ubuntu,      "Ubuntu",              VBOXOSTYPE_Ubuntu,      256,  12,  8 * _1K },
+        { SchemaDefs_OSTypeId_xandros,     "Xandros",             VBOXOSTYPE_Xandros,     256,  12,  8 * _1K },
+        { SchemaDefs_OSTypeId_freebsd,     "FreeBSD",             VBOXOSTYPE_FreeBSD,      64,   4,  2 * _1K },
+        { SchemaDefs_OSTypeId_openbsd,     "OpenBSD",             VBOXOSTYPE_OpenBSD,      64,   4,  2 * _1K },
+        { SchemaDefs_OSTypeId_netbsd,      "NetBSD",              VBOXOSTYPE_NetBSD,       64,   4,  2 * _1K },
+        { SchemaDefs_OSTypeId_netware,     "Netware",             VBOXOSTYPE_Netware,     128,   4,  4 * _1K },
+        { SchemaDefs_OSTypeId_solaris,     "Solaris",             VBOXOSTYPE_Solaris,     512,  12, 16 * _1K },
+	    { SchemaDefs_OSTypeId_opensolaris, "OpenSolaris",         VBOXOSTYPE_OpenSolaris, 512,  12, 16 * _1K },
+        { SchemaDefs_OSTypeId_l4,          "L4",                  VBOXOSTYPE_L4,           64,   4,  2 * _1K }
     };
 